JavaScript/jQuery Menu - Accessibility

Accessibility Features Overview

NOTE
The overall accessibility level of your application depends on the Menu features you use.
Accessibility Requirement Support Level
Right-to-Left Support
Keyboard Navigation Support
Screen Reader Support
Contrast Color Theme
Mobile Device Support
Lighthouse Accessibility Validation
Axe Accessibility Validation
WAVE Accessibility Validation
Section 508 Support
WCAG 2.x Support
  • - All component features meet the requirement
  • - Some component features may not meet the requirement
  • - Accessibility requirement is not supported

Accessibility Standards Compliance

The Menu component complies to all Section 508 and WCAG 2.x standards criteria.

Keyboard Navigation

A user can use the following keys to interact with the Menu component:

Key Action
Moves focus to the previous item. Closes the submenu and focuses on its parent item.
Moves focus to the next item. Opens the submenu of the focused item.
Moves focus to the previous item.
Moves focus to the next item.
Home Sets focus to the first item in the menu/submenu.
End Sets focus to the last item in the menu/submenu.
Space Switches the focused item to the selected state.
Enter Chooses the focused item.

If you set adaptivityEnabled to true, the Menu acts as a TreeView.

Use the registerKeyHandler(key, handler) method to implement a custom handler for a key.

JavaScript
  • function registerKeyHandlers () {
  • const menu = $("#menuContainer").dxMenu("instance");
  • menu.registerKeyHandler("backspace", function(e) {
  • // The argument "e" contains information on the event
  • });
  • menu.registerKeyHandler("space", function(e) {
  • // ...
  • });
  • }

Screen Reader Support

The Menu component supports screen readers and complies to WAI-ARIA standards.

React Menu - Accessibility

Accessibility Features Overview

NOTE
The overall accessibility level of your application depends on the Menu features you use.
Accessibility Requirement Support Level
Right-to-Left Support
Keyboard Navigation Support
Screen Reader Support
Contrast Color Theme
Mobile Device Support
Lighthouse Accessibility Validation
Axe Accessibility Validation
WAVE Accessibility Validation
Section 508 Support
WCAG 2.x Support
  • - All component features meet the requirement
  • - Some component features may not meet the requirement
  • - Accessibility requirement is not supported

Accessibility Standards Compliance

The Menu component complies to all Section 508 and WCAG 2.x standards criteria.

Keyboard Navigation

A user can use the following keys to interact with the Menu component:

Key Action
Moves focus to the previous item. Closes the submenu and focuses on its parent item.
Moves focus to the next item. Opens the submenu of the focused item.
Moves focus to the previous item.
Moves focus to the next item.
Home Sets focus to the first item in the menu/submenu.
End Sets focus to the last item in the menu/submenu.
Space Switches the focused item to the selected state.
Enter Chooses the focused item.

If you set adaptivityEnabled to true, the Menu acts as a TreeView.

Use the registerKeyHandler(key, handler) method to implement a custom handler for a key.

App.js
  • import React from 'react';
  • import 'devextreme/dist/css/dx.light.css';
  •  
  • import { Menu } from 'devextreme-react/menu';
  •  
  • class App extends React.Component {
  • constructor(props) {
  • super(props);
  •  
  • this.menuRef = React.createRef();
  • }
  •  
  • render() {
  • return (
  • <Menu ref={this.menuRef} />
  • );
  • }
  •  
  • get menu() {
  • return this.menuRef.current.instance;
  • }
  •  
  • componentDidMount() {
  • this.menu.registerKeyHandler('backspace', function(e) {
  • // The argument "e" contains information on the event
  • });
  • this.menu.registerKeyHandler('space', function(e) {
  • // ...
  • });
  • }
  • }
  •  
  • export default App;

Screen Reader Support

The Menu component supports screen readers and complies to WAI-ARIA standards.